startlist:	equ 38
openlib:	equ-408
exec:		equ 4
forbid:		equ-132
permit:		equ-138
;===============================================
start:
	lea	$70000,a0
	move.l	#$2000,d0
cloop:	clr.b	(a0)+
	dbf	d0,cloop
;------------------------------

	bsr	initcop
wait:
	btst	#6,$bfe001
	beq	ENDE

	move.w	#$6fff,d0
Time:	subq	#$1,d0
	cmp.w	#$00,d0
	bne	Time
	
Fscr:	
	lea	c1(pc),a3	; C1 in A3 Zwischenspeichern !!!
	move.l	a3,a0		

	lea	c2(pc),a1	; c2  nach  c1
	move.w	(a1),(a0)

	lea	c3(pc),a0	; c3  nach  c2
	move.w	(a0),(a1)

	lea	c4(pc),a1	; c4  nach  c3
	move.w	(a1),(a0)

	lea	c5(pc),a0	; c5  nach  c4
	move.w	(a0),(a1)	

	lea	c6(pc),a1	; c6  nach  c5
	move.w	(a1),(a0)

	lea	c7(pc),a0	; c7  nach  c6	
	move.w	(a0),(a1)
	
	lea	c8(pc),a1	; c8  nach  c7
	move.w	(a1),(a0)		

	lea	c9(pc),a0	; c9  nach  c8
	move.w	(a0),(a1)	

	lea	c10(pc),a1	; c10 nach  c9
	move.w	(a1),(a0)	

	lea	c11(pc),a0	; c11 nach  c10
	move.w	(a0),(a1)	

	lea	c12(pc),a1	; c12 nach  c11
	move.w	(a1),(a0)

	lea	c13(pc),a0	; c13 nach  c12	
	move.w	(a0),(a1)

	lea	c14(pc),a1	; c14 nach  c13
	move.w	(a1),(a0)		

	move.w 	(a3),(a1)	; c1  nach  c14
	bra	wait

initcop:
	move.w	#$4000,$dff09a	; IRQ-Enable ==> OFF
	move.w	#$0007,$dff0e0	;
	move.w	#$0000,$dff0e2	; Screenadresse Hi - LO
	move.w	#$1200,$dff100	; Bildschirm mit 1 Bitmap ein
	move.w	#$03a0,$dff096	;copper DMA aus
	
	move.l	exec,a6
	jsr	forbid(a6)	

	lea	$dff000,a5
	lea	Copper(pc),a0	
	move.l	a0,$80(a5)
	clr.w	$88(a5)
	move.w	#$8280,$96(a5)
	rts
;--------------------------------------------------
ENDE:
	move.l	exec,a6
	lea	GRname(pc),a1	
	jsr	openlib(a6)
	move.l	d0,a4	

	move.l	startlist(a4),$dff080	;Anfangscopper setzen !!!
	move.w	#$83e0,$dff096	

	move.l	exec,a6
	jsr	permit(a6)
	move.w	#$c000,$dff09a		;IRQ-Enable ==> ON
	rts				;zurueck zum Seka

;=========== Copperliste ==========================
copper:
	DC.W	$0180	; Hintergrundfarbe =>
co0:	dc.w	$0000	;	 	      Schwarz
	DC.W	$0182	; Schriftfarbe	   =>
co1:	dc.w	$0f00	;		      Rot
;------------------------------------------------
	dc.w	$9a0f,$fffe	; Z-154
	dc.w	$0180
c1:	dc.w	$00ff
	dc.w	$9b0f,$fffe	; Z-155
	dc.w	$0180
c2:	dc.w	$00df
	dc.w	$9c0f,$fffe	; Z-156
	dc.w	$0180
c3:	dc.w	$00bf
	dc.w 	$9d0f,$fffe	; Z-157
	dc.w	$0180
c4:	dc.w	$009f
	dc.w	$9e0f,$fffe	; Z-158
	dc.w	$0180
c5:	dc.w	$007f
	dc.w	$9f0f,$fffe	; Z-159
	dc.w	$0180
c6:	dc.w	$005f
	dc.w	$a00f,$fffe	; Z-160
	dc.w	$0180
c7:	dc.w	$003f

; --- Mitte des Farbstreifens !! ---

	dc.w	$a10f,$fffe	; Z-161
	dc.w	$0180
c8:	dc.w	$003f
	dc.w	$a20f,$fffe	; Z-162
	dc.w	$0180
c9:	dc.w	$005f
	dc.w	$a30f,$fffe	; Z-163
	dc.w	$0180
c10:	dc.w	$007f
	dc.w	$a40f,$fffe	; Z-164
	dc.w	$0180
c11:	dc.w	$009f
	dc.w	$a50f,$fffe	; Z-165
	dc.w	$0180
c12:	dc.w	$00bf
	dc.w	$a60f,$fffe	; Z-166
	dc.w	$0180
c13:	dc.w	$00df
	dc.w	$a70f,$fffe	; Z-167
	dc.w	$0180
c14:	dc.w	$00ff
	dc.w 	$a80f,$fffe	; Z-168
	dc.w 	$0180,$0000	; Hintergrundfarbe wieder => Schwarz
	DC.W    $FFFF,$FFFE	; Ende der Copperliste
;-----------------------------------------------
even
Grname:		dc.b	'graphics.library',0

