move.l $0004,a6               ; exec-base in a6
jsr    -132(a6)               ; switch to monotasking

move.l #coppersize,d0         ; size of copperlist in d0
move.l #$2,d1                 ; place in chip-ram
jsr    -198(a6)               ; reserve ram
move.l d0,copperram           ; d0 in chipcopper

lea.l  copperlist,a0          ; start of copperlist in a0
move.l d0,a1                  ; reserved ram in a1
copperloop:
move.l (a0),(a1)+             ; copy longword from a0 to a1
cmpi.l #$fffffffe,(a0)+       ; check for last longword in copperlist
bne    copperloop             ; non ? then jump to copperloop

lea.l  $dff000,a0             ; begin of custom-chips in a0

move.w #$03e0,$96(a0)         ; switch dma off
move.l copperram,$80(a0)      ; begin of copperlist in cop1lch
clr.w  $88(a0)                ; clear copjmp1
move.w #$8380,$96(a0)         ; switch dma on

neloop:
jmp neloop                    ; never ending loop

copperlist: dc.w $0100,$1200,$0102,$0000,$0104,$0000
            dc.w $0108,$0000,$010a,$0000,$0038,$0092
            dc.w $00d0,$0094,$008e,$2c81,$0090,$2cc1
            dc.w $0180,$0f00,$0182,$0fff,$0184,$0000
            dc.w $0186,$0000,$0188,$0000,$018a,$0000
            dc.w $018c,$0000,$018e,$0000,$0190,$0000
            dc.w $0192,$0000,$0194,$0000,$0196,$0000
            dc.w $0198,$0000,$019a,$0000,$019c,$0000
            dc.w $019e,$0000,$00e0,$0000,$00e2,$0000
            dc.w $ffff,$fffe
coppersize=*-copperlist

copperram:  dc.l 0
